/* Copyright 2015 Kevin Ryde.

   This file is part of x2gpm.

   x2gpm is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 3, or (at your option) any later
   version.

   x2gpm is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
   FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
   details.

   You should have received a copy of the GNU General Public License along
   with X2gpm; see the file COPYING.  Failing that, goto
   <http://www.gnu.org/licenses/>. */

#define _GNU_SOURCE
#include <assert.h>
#include <errno.h>
#include <fcntl.h>
#include <getopt.h>
#include <limits.h>
#include <locale.h>
#include <pwd.h>
#include <signal.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <syslog.h>
#include <unistd.h>
#include <utmp.h>
#include <sys/types.h>
#include <sys/poll.h>

#undef WUNTRACED  /* avoid redefines from <linux/wait.h> */
#undef WNOHANG
#undef WSTOPPED
#undef WEXITED
#undef WCONTINUED
#include <linux/keyboard.h>  /* for KG_CTRL */
#include <linux/kd.h>        /* for KDGKBMODE */

#include <gpm.h>

#include <X11/Xatom.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>

int
io_error_handler (Display *display)
{
  abort();
}

int
main (void)
{
  int old_stderr, temp_fd, len;
  Display *display;
  char buf[256];
  FILE *temp_file;

  putenv("HOME=/tmp");
  XSetIOErrorHandler(io_error_handler);

  temp_file = tmpfile ();
  if (! temp_file) {
    abort();
  }
  temp_fd = fileno(temp_file);
  
  /* temp_fd = open("/tmp/tempfile",O_TRUNC|O_WRONLY|O_CREAT); */
  /* if (temp_fd < 0) { */
  /*   perror("open tempfile"); */
  /*   abort(); */
  /* } */

  old_stderr = dup(2);
  if (old_stderr < 0) {
    abort();
  }
  if (dup2(temp_fd,2) < 0) {
    abort();
  }
  display = XOpenDisplay (":0");
  if (dup2(old_stderr,2) < 0) {
    abort();
  }

  lseek(temp_fd,SEEK_SET,0L);
  len = read(temp_fd, buf, sizeof(buf)-1);
  if (len > 0) {
    while (len > 0 && buf[len-1] == '\n') {
      len--;
    }
    buf[len] = '\0';
  } else {
    buf[0] = 0;
  }
  if (close(temp_fd) < 0) {
    abort();
  }
  printf ("pointer %p\n", display);
  printf ("buf %s\n", buf);


  return 0;
}
